
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>java集合框架02——Collection架构与源码分析 / iVAN</title>

    <meta name="description" content="java集合框架02——Collection架构与源码分析 Collection是一个接口,它主要的两个分支是List和Set.如下图所示:         List和Set都是接口,它们继承与Collection.List是有序的队列,可以用重复的元素:而Set是数学概念中的集合,不能有重复的元素.List和Set都有它们各自的实现类. 为了方便,我们抽象出AbstractCollection类来让其他类继承,该类实现类Collection中的绝大部分方法.AbstractList和AbstractSet都继承与AbstractCollection,具">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/bootstrap.css" rel="stylesheet">
  <link href="https://pic.ikafan.com/staticx/iamivan/2/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
  <script>
  var _hmt = _hmt || [];
  (function() {
    var hm = document.createElement("script");
    hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
    var s = document.getElementsByTagName("script")[0]; 
    s.parentNode.insertBefore(hm, s);
  })();
  </script>
 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="https://pic.ikafan.com/staticx/iamivan/2/assets/logo.png" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/">首页</a></li>
            <li><a href="/tag/互联网/">互联网</a></li>
            <li><a href="/tag/java/">java</a></li>
            <li><a href="/tag/mysql/">mysql</a></li>
            <li><a href="/tag/android/">Android</a></li>
            <li><a href="/tag/ios/">IOS</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    <div id="main" class="col-md-8">


<h1 class="mtitle">java集合框架02——Collection架构与源码分析</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>

    	<section>
		<article class="clearfix">
		<p>Collection是一个接口，它主要的两个分支是List和Set。如下图所示：</p>
<p><strong><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjA0MDgyMjE4NDAwNDA/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2L2ZvbnQvNWE2TDVMMlQvZm9udHNpemUvNDAwL2ZpbGwvSTBKQlFrRkNNQT09L2Rpc3NvbHZlLzcwL2dyYXZpdHkvQ2VudGVy.jpg"></strong></p>
<p>        List和Set都是接口，它们继承与Collection。<strong>List是有序的队列，可以用重复的元素；而Set是数学概念中的集合，不能有重复的元素。</strong>List和Set都有它们各自的实现类。<strong><br /></strong></p>
<p>为了方便，我们抽象出AbstractCollection类来让其他类继承，该类实现类Collection中的绝大部分方法。AbstractList和AbstractSet都继承与AbstractCollection，具体的List实现类继承与AbstractList，而Set的实现类则继承与AbstractSet。</p>
<p>        另外，Collection中有个iterator()方法，它的作用是返回一个Iterator接口。通常，我们通过Iterator迭代器来遍历集合。ListIterator是List接口所特有的，在List接口中，通过ListIterator()返回一个ListIterator对象。</p>
<p>        我们首先来阅读下这些 接口和抽象类以及他们的实现类中都有哪些方法：</p>
<h1><strong>1. Collection</strong></h1>
<p>        Collection的定义如下：</p>
<p><b>[java]</b> <a href="http://blog.csdn.net/eson_15/article/details/51139978#" rel="external nofollow noreferrer">view plain</a> <a href="http://blog.csdn.net/eson_15/article/details/51139978#" rel="external nofollow noreferrer">copy</a></p>
<p> <a href="https://code.csdn.net/snippets/1644590" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL2NvZGUuY3Nkbi5uZXQvYXNzZXRzL0NPREVfaWNvLnBuZw==.jpg"></a><a href="https://code.csdn.net/snippets/1644590/fork" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL2NvZGUuY3Nkbi5uZXQvYXNzZXRzL2ljb19mb3JrLnN2Zw==.jpg"></a></p>
<ol>
<li>public interface Collection&lt;E&gt; extends Iterable&lt;E&gt; {}  </li>
</ol>
<p>        从它的定义中可以看出，Collection是一个接口。它是一个高度抽象出来的集合，包含了集合的基本操作：添加、删除、清空、遍历、是否为空、获取大小等。<br />
<br />        Collection接口的所有子类（直接子类和简介子类）都必须实现2种构造函数：不带参数的构造函数和参数为Collection的构造函数。带参数的构造函数可以用来转换Collection的类型。下面是Collection接口中定义的API：</p>
<p><b>[java]</b> <a href="http://blog.csdn.net/eson_15/article/details/51139978#" rel="external nofollow noreferrer">view plain</a> <a href="http://blog.csdn.net/eson_15/article/details/51139978#" rel="external nofollow noreferrer">copy</a></p>
<p> <a href="https://code.csdn.net/snippets/1644590" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL2NvZGUuY3Nkbi5uZXQvYXNzZXRzL0NPREVfaWNvLnBuZw==.jpg"></a><a href="https://code.csdn.net/snippets/1644590/fork" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL2NvZGUuY3Nkbi5uZXQvYXNzZXRzL2ljb19mb3JrLnN2Zw==.jpg"></a></p>
<ol>
<li>// Collection的API  </li>
<li>abstract boolean         add(E object)  </li>
<li>abstract boolean         addAll(Collection&lt;? extends E&gt; collection)  </li>
<li>abstract void            clear()  </li>
<li>abstract boolean         contains(Object object)  </li>
<li>abstract boolean         containsAll(Collection&lt;?&gt; collection)  </li>
<li>abstract boolean         equals(Object object)  </li>
<li>abstract int             hashCode()  </li>
<li>abstract boolean         isEmpty()  </li>
<li>abstract Iterator&lt;E&gt;     iterator()  </li>
<li>abstract boolean         remove(Object object)  </li>
<li>abstract boolean         removeAll(Collection&lt;?&gt; collection)  </li>
<li>abstract boolean         retainAll(Collection&lt;?&gt; collection)  </li>
<li>abstract int             size()  </li>
<li>abstract &lt;T&gt; T[]         toArray(T[] array)  </li>
<li>abstract Object[]        toArray()  </li>
</ol>

<h1><strong>2. List</strong></h1>
<p>        List的定义如下：</p>
<p><b>[java]</b> <a href="http://blog.csdn.net/eson_15/article/details/51139978#" rel="external nofollow noreferrer">view plain</a> <a href="http://blog.csdn.net/eson_15/article/details/51139978#" rel="external nofollow noreferrer">copy</a></p>
<p> <a href="https://code.csdn.net/snippets/1644590" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL2NvZGUuY3Nkbi5uZXQvYXNzZXRzL0NPREVfaWNvLnBuZw==.jpg"></a><a href="https://code.csdn.net/snippets/1644590/fork" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL2NvZGUuY3Nkbi5uZXQvYXNzZXRzL2ljb19mb3JrLnN2Zw==.jpg"></a></p>
<ol>
<li>public interface List&lt;E&gt; extends Collection&lt;E&gt; {}  </li>
</ol>
<p>        从List定义中可以看出，它继承与Collection接口，即List是集合的一种。List是有序的队列，List中的每一个元素都有一个索引，第一个元素的索引值为0，往后的元素的索引值依次+1.，List中允许有重复的元素。<br />
<br />        List继承Collection自然包含了Collection的所有接口，由于List是有序队列，所以它也有自己额外的API接口。API如下：</p>
<p><b>[java]</b> <a href="http://blog.csdn.net/eson_15/article/details/51139978#" rel="external nofollow noreferrer">view plain</a> <a href="http://blog.csdn.net/eson_15/article/details/51139978#" rel="external nofollow noreferrer">copy</a></p>
<p> <a href="https://code.csdn.net/snippets/1644590" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL2NvZGUuY3Nkbi5uZXQvYXNzZXRzL0NPREVfaWNvLnBuZw==.jpg"></a><a href="https://code.csdn.net/snippets/1644590/fork" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL2NvZGUuY3Nkbi5uZXQvYXNzZXRzL2ljb19mb3JrLnN2Zw==.jpg"></a></p>
<ol>
<li>// Collection的API  </li>
<li>abstract boolean         add(E object)  </li>
<li>abstract boolean         addAll(Collection&lt;? extends E&gt; collection)  </li>
<li>abstract void            clear()  </li>
<li>abstract boolean         contains(Object object)  </li>
<li>abstract boolean         containsAll(Collection&lt;?&gt; collection)  </li>
<li>abstract boolean         equals(Object object)  </li>
<li>abstract int             hashCode()  </li>
<li>abstract boolean         isEmpty()  </li>
<li>abstract Iterator&lt;E&gt;     iterator()  </li>
<li>abstract boolean         remove(Object object)  </li>
<li>abstract boolean         removeAll(Collection&lt;?&gt; collection)  </li>
<li>abstract boolean         retainAll(Collection&lt;?&gt; collection)  </li>
<li>abstract int             size()  </li>
<li>abstract &lt;T&gt; T[]         toArray(T[] array)  </li>
<li>abstract Object[]        toArray()  </li>
<li>// 相比与Collection，List新增的API：  </li>
<li>abstract void                add(int location, E object) //在指定位置添加元素  </li>
<li>abstract boolean             addAll(int location, Collection&lt;? extends E&gt; collection) //在指定位置添加其他集合中的元素  </li>
<li>abstract E                   get(int location) //获取指定位置的元素  </li>
<li>abstract int                 indexOf(Object object) //获得指定元素的索引  </li>
<li>abstract int                 lastIndexOf(Object object) //从右边的索引  </li>
<li>abstract ListIterator&lt;E&gt;     listIterator(int location) //获得iterator  </li>
<li>abstract ListIterator&lt;E&gt;     listIterator()  </li>
<li>abstract E                   remove(int location) //删除指定位置的元素  </li>
<li>abstract E                   set(int location, E object) //修改指定位置的元素  </li>
<li>abstract List&lt;E&gt;             subList(int start, int end) //获取子list  </li>
</ol>

<h1><strong>3. Set</strong></h1>
<p>        Set的定义如下：</p>
<p><b>[java]</b> <a href="http://blog.csdn.net/eson_15/article/details/51139978#" rel="external nofollow noreferrer">view plain</a> <a href="http://blog.csdn.net/eson_15/article/details/51139978#" rel="external nofollow noreferrer">copy</a></p>
<p> <a href="https://code.csdn.net/snippets/1644590" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL2NvZGUuY3Nkbi5uZXQvYXNzZXRzL0NPREVfaWNvLnBuZw==.jpg"></a><a href="https://code.csdn.net/snippets/1644590/fork" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL2NvZGUuY3Nkbi5uZXQvYXNzZXRzL2ljb19mb3JrLnN2Zw==.jpg"></a></p>
<ol>
<li>public interface Set&lt;E&gt; extends Collection&lt;E&gt; {}  </li>
</ol>
<p>        Set也继承与Collection接口，且里面不能有重复元素。关于API，Set与Collection的API完全一样，不在赘述。</p>
<h1><strong>4. AbstractCollection</strong></h1>
<p><b>[java]</b> <a href="http://blog.csdn.net/eson_15/article/details/51139978#" rel="external nofollow noreferrer">view plain</a> <a href="http://blog.csdn.net/eson_15/article/details/51139978#" rel="external nofollow noreferrer">copy</a></p>
<p> <a href="https://code.csdn.net/snippets/1644590" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL2NvZGUuY3Nkbi5uZXQvYXNzZXRzL0NPREVfaWNvLnBuZw==.jpg"></a><a href="https://code.csdn.net/snippets/1644590/fork" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL2NvZGUuY3Nkbi5uZXQvYXNzZXRzL2ljb19mb3JrLnN2Zw==.jpg"></a></p>
<ol>
<li>public abstract class AbstractCollection&lt;E&gt; implements Collection&lt;E&gt; {}  </li>
</ol>
<p>        AbstractCollection是一个抽象类，它实现了Collection中除了iterator()和size()之外的所有方法。AbstractCollection的主要作用是方便其他类实现Collection.，比如ArrayList、LinkedList等。它们想要实现Collection接口，通过集成AbstractCollection就已经实现大部分方法了，再实现一下iterator()和size()即可。</p>
<p>        下面看一下AbstractCollection实现的部分方法的源码：</p>
<p><b>[java]</b> <a href="http://blog.csdn.net/eson_15/article/details/51139978#" rel="external nofollow noreferrer">view plain</a> <a href="http://blog.csdn.net/eson_15/article/details/51139978#" rel="external nofollow noreferrer">copy</a></p>
<p> <a href="https://code.csdn.net/snippets/1644590" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL2NvZGUuY3Nkbi5uZXQvYXNzZXRzL0NPREVfaWNvLnBuZw==.jpg"></a><a href="https://code.csdn.net/snippets/1644590/fork" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL2NvZGUuY3Nkbi5uZXQvYXNzZXRzL2ljb19mb3JrLnN2Zw==.jpg"></a></p>
<ol>
<li>public abstract class AbstractCollection&lt;E&gt; implements Collection&lt;E&gt; {  </li>
<li>    protected AbstractCollection() {  </li>
<li>    }  </li>
<li>  </li>
<li>    public abstract Iterator&lt;E&gt; iterator();//iterator()方法没有实现  </li>
<li>  </li>
<li>    public abstract int size(); //size()方法也没有实现  </li>
<li>  </li>
<li>    public boolean isEmpty() { //检测集合是否为空  </li>
<li>        return size() == 0;  </li>
<li>    }  </li>
<li>    /*检查集合中是否包含特定对象*/  </li>
<li>    public boolean contains(Object o) {   </li>
<li>        Iterator&lt;E&gt; it = iterator();  </li>
<li>        if (o==null) {  </li>
<li>            while (it.hasNext()) //从这里可以看出，任何非空集合都包含null  </li>
<li>                if (it.next()==null)  </li>
<li>                    return true;  </li>
<li>        } else {  </li>
<li>            while (it.hasNext())  </li>
<li>                if (o.equals(it.next()))  </li>
<li>                    return true;  </li>
<li>        }  </li>
<li>        return false;  </li>
<li>    }  </li>
<li>    /*将集合转变成数组*/  </li>
<li>    public Object[] toArray() {  </li>
<li>        // Estimate size of array; be prepared to see more or fewer elements  </li>
<li>        Object[] r = new Object[size()]; //创建与集合大小相同的数组  </li>
<li>        Iterator&lt;E&gt; it = iterator();  </li>
<li>        for (int i = 0; i &lt; r.length; i++) {  </li>
<li>            if (! it.hasNext()) // fewer elements than expected  </li>
<li>                //Arrays.copy(**,**)的第二个参数是待copy的长度，如果这个长度大于r，则保留r的长度  </li>
<li>                return Arrays.copyOf(r, i);  </li>
<li>            r[i] = it.next();  </li>
<li>        }  </li>
<li>        return it.hasNext() ? finishToArray(r, it) : r;  </li>
<li>    }  </li>
<li>  </li>
<li>    public &lt;T&gt; T[] toArray(T[] a) {  </li>
<li>        // Estimate size of array; be prepared to see more or fewer elements  </li>
<li>        int size = size();  </li>
<li>        T[] r = a.length &gt;= size ? a :  </li>
<li>                  (T[])java.lang.reflect.Array  </li>
<li>                  .newInstance(a.getClass().getComponentType(), size);  </li>
<li>        Iterator&lt;E&gt; it = iterator();  </li>
<li>  </li>
<li>        for (int i = 0; i &lt; r.length; i++) {  </li>
<li>            if (! it.hasNext()) { // fewer elements than expected  </li>
<li>                if (a == r) {  </li>
<li>                    r[i] = null; // null-terminate  </li>
<li>                } else if (a.length &lt; i) {  </li>
<li>                    return Arrays.copyOf(r, i);  </li>
<li>                } else {  </li>
<li>                    System.arraycopy(r, 0, a, 0, i);  </li>
<li>                    if (a.length &gt; i) {  </li>
<li>                        a[i] = null;  </li>
<li>                    }  </li>
<li>                }  </li>
<li>                return a;  </li>
<li>            }  </li>
<li>            r[i] = (T)it.next();  </li>
<li>        }  </li>
<li>        // more elements than expected  </li>
<li>        return it.hasNext() ? finishToArray(r, it) : r;  </li>
<li>    }  </li>
<li>  </li>
<li>    private static &lt;T&gt; T[] finishToArray(T[] r, Iterator&lt;?&gt; it) {  </li>
<li>        int i = r.length;  </li>
<li>        while (it.hasNext()) {  </li>
<li>            int cap = r.length;  </li>
<li>            if (i == cap) {  </li>
<li>                int newCap = cap + (cap &gt;&gt; 1) + 1;  </li>
<li>                // overflow-conscious code  </li>
<li>                if (newCap - MAX_ARRAY_SIZE &gt; 0)  </li>
<li>                    newCap = hugeCapacity(cap + 1);  </li>
<li>                r = Arrays.copyOf(r, newCap);  </li>
<li>            }  </li>
<li>            r[i++] = (T)it.next();  </li>
<li>        }  </li>
<li>        // trim if overallocated  </li>
<li>        return (i == r.length) ? r : Arrays.copyOf(r, i);  </li>
<li>    }  </li>
<li>      </li>
<li>    private static int hugeCapacity(int minCapacity) {  </li>
<li>        if (minCapacity &lt; 0) // overflow  </li>
<li>            throw new OutOfMemoryError  </li>
<li>                ("Required array size too large");  </li>
<li>        return (minCapacity &gt; MAX_ARRAY_SIZE) ?  </li>
<li>            Integer.MAX_VALUE :  </li>
<li>            MAX_ARRAY_SIZE;  </li>
<li>    }  </li>
<li>  </li>
<li>    // 删除对象o  </li>
<li>    public boolean remove(Object o) {  </li>
<li>        Iterator&lt;E&gt; it = iterator();  </li>
<li>        if (o==null) {  </li>
<li>            while (it.hasNext()) {  </li>
<li>                if (it.next()==null) {  </li>
<li>                    it.remove();  </li>
<li>                    return true;  </li>
<li>                }  </li>
<li>            }  </li>
<li>        } else {  </li>
<li>            while (it.hasNext()) {  </li>
<li>                if (o.equals(it.next())) {  </li>
<li>                    it.remove();  </li>
<li>                    return true;  </li>
<li>                }  </li>
<li>            }  </li>
<li>        }  </li>
<li>        return false;  </li>
<li>    }  </li>
<li>   &lt;pre name="code" class="java"&gt;    // 判断是否包含集合c中所有元素  </li>
<li>    public boolean containsAll(Collection&lt;?&gt; c) {  </li>
<li>        for (Object e : c)  </li>
<li>            if (!contains(e))  </li>
<li>                return false;  </li>
<li>        return true;  </li>
<li>    }  </li>
<li>  </li>
<li>    //添加集合c中所有元素  </li>
<li>    public boolean addAll(Collection&lt;? extends E&gt; c) {  </li>
<li>        boolean modified = false;  </li>
<li>        for (E e : c)  </li>
<li>            if (add(e))  </li>
<li>                modified = true;  </li>
<li>        return modified;  </li>
<li>    }  </li>
<li>  </li>
<li>    //删除集合c中所有元素（如果存在的话）  </li>
<li>    public boolean removeAll(Collection&lt;?&gt; c) {  </li>
<li>        boolean modified = false;  </li>
<li>        Iterator&lt;?&gt; it = iterator();  </li>
<li>        while (it.hasNext()) {  </li>
<li>            if (c.contains(it.next())) {  </li>
<li>                it.remove();  </li>
<li>                modified = true;  </li>
<li>            }  </li>
<li>        }  </li>
<li>        return modified;  </li>
<li>    }  </li>
<li>  </li>
<li>    //清空  </li>
<li>    public void clear() {  </li>
<li>        Iterator&lt;E&gt; it = iterator();  </li>
<li>        while (it.hasNext()) {  </li>
<li>            it.next();  </li>
<li>            it.remove();  </li>
<li>        }  </li>
<li>    }  </li>
<li>  </li>
<li>    //将集合元素显示成[String]  </li>
<li>    public String toString() {  </li>
<li>        Iterator&lt;E&gt; it = iterator();  </li>
<li>        if (! it.hasNext())  </li>
<li>            return "[]";  </li>
<li>  </li>
<li>        StringBuilder sb = new StringBuilder();  </li>
<li>        sb.append('[');  </li>
<li>        for (;;) {  </li>
<li>            E e = it.next();  </li>
<li>            sb.append(e == this ? "(this Collection)" : e);  </li>
<li>            if (! it.hasNext())  </li>
<li>                return sb.append(']').toString();  </li>
<li>            sb.append(',').append(' ');  </li>
<li>        }  </li>
<li>    }  </li>
<li>  </li>
<li>}  </li>
</ol>

<h1><strong>5. AbstractList</strong></h1>
<p>        AbstractList的定义如下：</p>
<p><b>[java]</b> <a href="http://blog.csdn.net/eson_15/article/details/51139978#" rel="external nofollow noreferrer">view plain</a> <a href="http://blog.csdn.net/eson_15/article/details/51139978#" rel="external nofollow noreferrer">copy</a></p>
<p> <a href="https://code.csdn.net/snippets/1644590" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL2NvZGUuY3Nkbi5uZXQvYXNzZXRzL0NPREVfaWNvLnBuZw==.jpg"></a><a href="https://code.csdn.net/snippets/1644590/fork" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL2NvZGUuY3Nkbi5uZXQvYXNzZXRzL2ljb19mb3JrLnN2Zw==.jpg"></a></p>
<ol>
<li>public abstract class AbstractList&lt;E&gt; extends AbstractCollection&lt;E&gt; implements List&lt;E&gt; {}  </li>
</ol>
<p>        从定义中可以看出，AbstractList是一个继承AbstractCollection，并且实现了List接口的抽象类。它实现了List中除了size()、get(int location)之外的方法。<br />
<br />        AbstractList的主要作用：它实现了List接口中的大部分函数，从而方便其它类继承List。另外，和AbstractCollection相比，AbstractList抽象类中，实现了iterator()方法。</p>
<p>        AbstractList抽象类的源码如下：</p>
<p><b>[java]</b> <a href="http://blog.csdn.net/eson_15/article/details/51139978#" rel="external nofollow noreferrer">view plain</a> <a href="http://blog.csdn.net/eson_15/article/details/51139978#" rel="external nofollow noreferrer">copy</a></p>
<p> <a href="https://code.csdn.net/snippets/1644590" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL2NvZGUuY3Nkbi5uZXQvYXNzZXRzL0NPREVfaWNvLnBuZw==.jpg"></a><a href="https://code.csdn.net/snippets/1644590/fork" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL2NvZGUuY3Nkbi5uZXQvYXNzZXRzL2ljb19mb3JrLnN2Zw==.jpg"></a></p>
<ol>
<li>public abstract class AbstractList&lt;E&gt; extends AbstractCollection&lt;E&gt; implements List&lt;E&gt; {  </li>
<li>      </li>
<li>    protected AbstractList() {  </li>
<li>    }  </li>
<li>  </li>
<li>    public boolean add(E e) {  </li>
<li>        add(size(), e);  </li>
<li>        return true;  </li>
<li>    }  </li>
<li>  </li>
<li>    abstract public E get(int index);  </li>
<li>      </li>
<li>    public E set(int index, E element) {  </li>
<li>        throw new UnsupportedOperationException();  </li>
<li>    }  </li>
<li>  </li>
<li>    public void add(int index, E element) {  </li>
<li>        throw new UnsupportedOperationException();  </li>
<li>    }  </li>
<li>  </li>
<li>    public E remove(int index) {  </li>
<li>        throw new UnsupportedOperationException();  </li>
<li>    }  </li>
<li>  </li>
<li>/***************************** Search Operations**********************************/  </li>
<li>    public int indexOf(Object o) { //搜索对象o的索引  </li>
<li>        ListIterator&lt;E&gt; it = listIterator();  </li>
<li>        if (o==null) {  </li>
<li>            while (it.hasNext())  </li>
<li>                if (it.next()==null) //执行it.next()，会先返回it指向位置的值，然后it会移到下一个位置  </li>
<li>                    return it.previousIndex(); //所以要返回it.previousIndex(); 关于it几个方法的源码在下面  </li>
<li>        } else {  </li>
<li>            while (it.hasNext())  </li>
<li>                if (o.equals(it.next()))  </li>
<li>                    return it.previousIndex();  </li>
<li>        }  </li>
<li>        return -1;  </li>
<li>    }  </li>
<li>  </li>
<li>    public int lastIndexOf(Object o) {  </li>
<li>        ListIterator&lt;E&gt; it = listIterator(size());  </li>
<li>        if (o==null) {  </li>
<li>            while (it.hasPrevious())  </li>
<li>                if (it.previous()==null)  </li>
<li>                    return it.nextIndex();  </li>
<li>        } else {  </li>
<li>            while (it.hasPrevious())  </li>
<li>                if (o.equals(it.previous()))  </li>
<li>                    return it.nextIndex();  </li>
<li>        }  </li>
<li>        return -1;  </li>
<li>    }  </li>
<li>/**********************************************************************************/  </li>
<li>  </li>
<li>/****************************** Bulk Operations ***********************************/  </li>
<li>    public void clear() {  </li>
<li>        removeRange(0, size());  </li>
<li>    }  </li>
<li>  </li>
<li>    public boolean addAll(int index, Collection&lt;? extends E&gt; c) {  </li>
<li>        rangeCheckForAdd(index);  </li>
<li>        boolean modified = false;  </li>
<li>        for (E e : c) {  </li>
<li>            add(index++, e);  </li>
<li>            modified = true;  </li>
<li>        }  </li>
<li>        return modified;  </li>
<li>    }  </li>
<li>  </li>
<li>    protected void removeRange(int fromIndex, int toIndex) {  </li>
<li>        ListIterator&lt;E&gt; it = listIterator(fromIndex);  </li>
<li>        for (int i=0, n=toIndex-fromIndex; i&lt;n; i++) {  </li>
<li>            it.next();  </li>
<li>            it.remove();  </li>
<li>        }  </li>
<li>    }  </li>
<li>/**********************************************************************************/  </li>
<li>  </li>
<li>/********************************* Iterators **************************************/  </li>
<li>    public Iterator&lt;E&gt; iterator() {  </li>
<li>        return new Itr();  </li>
<li>    }  </li>
<li>  </li>
<li>    public ListIterator&lt;E&gt; listIterator() {  </li>
<li>        return listIterator(0); //返回的iterator索引从0开始  </li>
<li>    }  </li>
<li>  </li>
<li>    public ListIterator&lt;E&gt; listIterator(final int index) {  </li>
<li>        rangeCheckForAdd(index); //首先检查index范围是否正确  </li>
<li>  </li>
<li>        return new ListItr(index); //ListItr继承与Itr且实现了ListIterator接口，Itr实现了Iterator接口，往下看  </li>
<li>    }  </li>
<li>  </li>
<li>    private class Itr implements Iterator&lt;E&gt; {          </li>
<li>        int cursor = 0; //元素的索引，当调用next()方法时，返回当前索引的值  </li>
<li>        int lastRet = -1; //lastRet也是元素的索引，但如果删掉此元素，该值置为-1  </li>
<li>         /* </li>
<li>         *迭代器都有个modCount值，在使用迭代器的时候，如果使用remove,add等方法的时候都会修改modCount， </li>
<li>         *在迭代的时候需要保持单线程的唯一操作，如果期间进行了插入或者删除，modCount就会被修改，迭代器就会检测到被并发修改，从而出现运行时异常。 </li>
<li>         *举个简单的例子，现在某个线程正在遍历一个List，另一个线程对List中的某个值做了删除，那原来的线程用原来的迭代器当然无法正常遍历了 </li>
<li>         */  </li>
<li>        int expectedModCount = modCount;  </li>
<li>  </li>
<li>        public boolean hasNext() {  </li>
<li>            return cursor != size(); //当索引值和元素个数相同时表示没有下一个元素了，索引是从0到size-1  </li>
<li>        }  </li>
<li>  </li>
<li>        public E next() {  </li>
<li>            checkForComodification(); //检查modCount是否改变  </li>
<li>            try {  </li>
<li>                int i = cursor; //next()方法主要做了两件事：  </li>
<li>                E next = get(i);   </li>
<li>                lastRet = i;  </li>
<li>                cursor = i + 1; //1.将索引指向了下一个位置  </li>
<li>                return next; //2. 返回当前索引的值  </li>
<li>            } catch (IndexOutOfBoundsException e) {  </li>
<li>                checkForComodification();  </li>
<li>                throw new NoSuchElementException();  </li>
<li>            }  </li>
<li>        }  </li>
<li>  </li>
<li>        public void remove() {  </li>
<li>            if (lastRet &lt; 0) //lastRet&lt;0表示已经不存在了  </li>
<li>                throw new IllegalStateException();  </li>
<li>            checkForComodification();  </li>
<li>  </li>
<li>            try {  </li>
<li>                AbstractList.this.remove(lastRet);  </li>
<li>                if (lastRet &lt; cursor)  </li>
<li>                    cursor--; //原位置的索引值减小了1，但是实际位置没变  </li>
<li>                lastRet = -1; //置为-1表示已删除  </li>
<li>                expectedModCount = modCount;  </li>
<li>            } catch (IndexOutOfBoundsException e) {  </li>
<li>                throw new ConcurrentModificationException();  </li>
<li>            }  </li>
<li>        }  </li>
<li>  </li>
<li>        final void checkForComodification() {  </li>
<li>            if (modCount != expectedModCount)  </li>
<li>                throw new ConcurrentModificationException();  </li>
<li>        }  </li>
<li>    }  </li>
<li>  </li>
<li>    private class ListItr extends Itr implements ListIterator&lt;E&gt; {  </li>
<li>        ListItr(int index) {  </li>
<li>            cursor = index;  </li>
<li>        }  </li>
<li>  </li>
<li>        public boolean hasPrevious() {  </li>
<li>            return cursor != 0;  </li>
<li>        }  </li>
<li>  </li>
<li>        public E previous() {  </li>
<li>            checkForComodification();  </li>
<li>            try {  </li>
<li>                int i = cursor - 1; //previous()方法中也做了两件事：  </li>
<li>                E previous = get(i); //1. 将索引向前移动一位  </li>
<li>                lastRet = cursor = i; //2. 返回索引处的值  </li>
<li>                return previous;  </li>
<li>            } catch (IndexOutOfBoundsException e) {  </li>
<li>                checkForComodification();  </li>
<li>                throw new NoSuchElementException();  </li>
<li>            }  </li>
<li>        }  </li>
<li>  </li>
<li>        public int nextIndex() { //iterator中的index本来就是下一个位置，在next()方法中可以看出  </li>
<li>            return cursor;  </li>
<li>        }  </li>
<li>  </li>
<li>        public int previousIndex() {  </li>
<li>            return cursor-1;  </li>
<li>        }  </li>
<li>  </li>
<li>        public void set(E e) { //修改当前位置的元素  </li>
<li>            if (lastRet &lt; 0)  </li>
<li>                throw new IllegalStateException();  </li>
<li>            checkForComodification();  </li>
<li>  </li>
<li>            try {  </li>
<li>                AbstractList.this.set(lastRet, e);  </li>
<li>                expectedModCount = modCount;  </li>
<li>            } catch (IndexOutOfBoundsException ex) {  </li>
<li>                throw new ConcurrentModificationException();  </li>
<li>            }  </li>
<li>        }  </li>
<li>  </li>
<li>        public void add(E e) { //在当前位置添加元素  </li>
<li>            checkForComodification();  </li>
<li>  </li>
<li>            try {  </li>
<li>                int i = cursor;  </li>
<li>                AbstractList.this.add(i, e);  </li>
<li>                lastRet = -1;  </li>
<li>                cursor = i + 1;  </li>
<li>                expectedModCount = modCount;  </li>
<li>            } catch (IndexOutOfBoundsException ex) {  </li>
<li>                throw new ConcurrentModificationException();  </li>
<li>            }  </li>
<li>        }  </li>
<li>    }  </li>
<li>/**********************************************************************************/  </li>
<li>  </li>
<li>    //获得子List，详细源码往下看SubList类  </li>
<li>    public List&lt;E&gt; subList(int fromIndex, int toIndex) {  </li>
<li>        return (this instanceof RandomAccess ?  </li>
<li>                new RandomAccessSubList&lt;&gt;(this, fromIndex, toIndex) :  </li>
<li>                new SubList&lt;&gt;(this, fromIndex, toIndex));  </li>
<li>    }  </li>
<li>  </li>
<li>/*************************** Comparison and hashing *******************************/  </li>
<li>    public boolean equals(Object o) {  </li>
<li>        if (o == this)  </li>
<li>            return true;  </li>
<li>        if (!(o instanceof List))  </li>
<li>            return false;  </li>
<li>  </li>
<li>        ListIterator&lt;E&gt; e1 = listIterator();  </li>
<li>        ListIterator e2 = ((List) o).listIterator();  </li>
<li>        while (e1.hasNext() &amp;&amp; e2.hasNext()) {  </li>
<li>            E o1 = e1.next();  </li>
<li>            Object o2 = e2.next();  </li>
<li>            if (!(o1==null ? o2==null : o1.equals(o2)))  </li>
<li>                return false;  </li>
<li>        }  </li>
<li>        return !(e1.hasNext() || e2.hasNext());  </li>
<li>    }  </li>
<li>  </li>
<li>    public int hashCode() { //hashcode  </li>
<li>        int hashCode = 1;  </li>
<li>        for (E e : this)  </li>
<li>            hashCode = 31*hashCode + (e==null ? 0 : e.hashCode());  </li>
<li>        return hashCode;  </li>
<li>    }  </li>
<li>/**********************************************************************************/   </li>
<li>    protected transient int modCount = 0;  </li>
<li>  </li>
<li>    private void rangeCheckForAdd(int index) {  </li>
<li>        if (index &lt; 0 || index &gt; size())  </li>
<li>            throw new IndexOutOfBoundsException(outOfBoundsMsg(index));  </li>
<li>    }  </li>
<li>  </li>
<li>    private String outOfBoundsMsg(int index) {  </li>
<li>        return "Index: "+index+", Size: "+size();  </li>
<li>    }  </li>
<li>}  </li>
<li>  </li>
<li>class SubList&lt;E&gt; extends AbstractList&lt;E&gt; {  </li>
<li>    private final AbstractList&lt;E&gt; l;  </li>
<li>    private final int offset;  </li>
<li>    private int size;  </li>
<li>    /* 从SubList源码可以看出，当需要获得一个子List时，底层并不是真正的返回一个子List，还是原来的List，只不过 </li>
<li>    * 在操作的时候，索引全部限定在用户所需要的子List部分而已 </li>
<li>    */  </li>
<li>    SubList(AbstractList&lt;E&gt; list, int fromIndex, int toIndex) {  </li>
<li>        if (fromIndex &lt; 0)  </li>
<li>            throw new IndexOutOfBoundsException("fromIndex = " + fromIndex);  </li>
<li>        if (toIndex &gt; list.size())  </li>
<li>            throw new IndexOutOfBoundsException("toIndex = " + toIndex);  </li>
<li>        if (fromIndex &gt; toIndex)  </li>
<li>            throw new IllegalArgumentException("fromIndex(" + fromIndex +  </li>
<li>                                               ") &gt; toIndex(" + toIndex + ")");  </li>
<li>        l = list; //原封不动的将原来的list赋给l  </li>
<li>        offset = fromIndex; //偏移量，用在操作新的子List中  </li>
<li>        size = toIndex - fromIndex; //子List的大小，所以子List中不包括toIndex处的值，即子List中包括左边不包括右边  </li>
<li>        this.modCount = l.modCount;  </li>
<li>    }  </li>
<li>    //注意下面所有的操作都在索引上加上偏移量offset，相当于在原来List的副本上操作子List  </li>
<li>    public E set(int index, E element) {  </li>
<li>        rangeCheck(index);  </li>
<li>        checkForComodification();  </li>
<li>        return l.set(index+offset, element);  </li>
<li>    }  </li>
<li>  </li>
<li>    public E get(int index) {  </li>
<li>        rangeCheck(index);  </li>
<li>        checkForComodification();  </li>
<li>        return l.get(index+offset);  </li>
<li>    }  </li>
<li>  </li>
<li>    public int size() {  </li>
<li>        checkForComodification();  </li>
<li>        return size;  </li>
<li>    }  </li>
<li>  </li>
<li>    public void add(int index, E element) {  </li>
<li>        rangeCheckForAdd(index);  </li>
<li>        checkForComodification();  </li>
<li>        l.add(index+offset, element);  </li>
<li>        this.modCount = l.modCount;  </li>
<li>        size++;  </li>
<li>    }  </li>
<li>  </li>
<li>    public E remove(int index) {  </li>
<li>        rangeCheck(index);  </li>
<li>        checkForComodification();  </li>
<li>        E result = l.remove(index+offset);  </li>
<li>        this.modCount = l.modCount;  </li>
<li>        size--;  </li>
<li>        return result;  </li>
<li>    }  </li>
<li>  </li>
<li>    protected void removeRange(int fromIndex, int toIndex) {  </li>
<li>        checkForComodification();  </li>
<li>        l.removeRange(fromIndex+offset, toIndex+offset);  </li>
<li>        this.modCount = l.modCount;  </li>
<li>        size -= (toIndex-fromIndex);  </li>
<li>    }  </li>
<li>  </li>
<li>    public boolean addAll(Collection&lt;? extends E&gt; c) {  </li>
<li>        return addAll(size, c);  </li>
<li>    }  </li>
<li>  </li>
<li>    public boolean addAll(int index, Collection&lt;? extends E&gt; c) {  </li>
<li>        rangeCheckForAdd(index);  </li>
<li>        int cSize = c.size();  </li>
<li>        if (cSize==0)  </li>
<li>            return false;  </li>
<li>  </li>
<li>        checkForComodification();  </li>
<li>        l.addAll(offset+index, c);  </li>
<li>        this.modCount = l.modCount;  </li>
<li>        size += cSize;  </li>
<li>        return true;  </li>
<li>    }  </li>
<li>  </li>
<li>    public Iterator&lt;E&gt; iterator() {  </li>
<li>        return listIterator();  </li>
<li>    }  </li>
<li>  </li>
<li>    public ListIterator&lt;E&gt; listIterator(final int index) {  </li>
<li>        checkForComodification();  </li>
<li>        rangeCheckForAdd(index);  </li>
<li>  </li>
<li>        return new ListIterator&lt;E&gt;() {  </li>
<li>            private final ListIterator&lt;E&gt; i = l.listIterator(index+offset); //相当子List的索引0  </li>
<li>  </li>
<li>            public boolean hasNext() {  </li>
<li>                return nextIndex() &lt; size;  </li>
<li>            }  </li>
<li>  </li>
<li>            public E next() {  </li>
<li>                if (hasNext())  </li>
<li>                    return i.next();  </li>
<li>                else  </li>
<li>                    throw new NoSuchElementException();  </li>
<li>            }  </li>
<li>  </li>
<li>            public boolean hasPrevious() {  </li>
<li>                return previousIndex() &gt;= 0;  </li>
<li>            }  </li>
<li>  </li>
<li>            public E previous() {  </li>
<li>                if (hasPrevious())  </li>
<li>                    return i.previous();  </li>
<li>                else  </li>
<li>                    throw new NoSuchElementException();  </li>
<li>            }  </li>
<li>  </li>
<li>            public int nextIndex() {  </li>
<li>                return i.nextIndex() - offset;  </li>
<li>            }  </li>
<li>  </li>
<li>            public int previousIndex() {  </li>
<li>                return i.previousIndex() - offset;  </li>
<li>            }  </li>
<li>  </li>
<li>            public void remove() {  </li>
<li>                i.remove();  </li>
<li>                SubList.this.modCount = l.modCount;  </li>
<li>                size--;  </li>
<li>            }  </li>
<li>  </li>
<li>            public void set(E e) {  </li>
<li>                i.set(e);  </li>
<li>            }  </li>
<li>  </li>
<li>            public void add(E e) {  </li>
<li>                i.add(e);  </li>
<li>                SubList.this.modCount = l.modCount;  </li>
<li>                size++;  </li>
<li>            }  </li>
<li>        };  </li>
<li>    }  </li>
<li>  </li>
<li>    public List&lt;E&gt; subList(int fromIndex, int toIndex) {  </li>
<li>        return new SubList&lt;&gt;(this, fromIndex, toIndex);  </li>
<li>    }  </li>
<li>  </li>
<li>    private void rangeCheck(int index) {  </li>
<li>        if (index &lt; 0 || index &gt;= size)  </li>
<li>            throw new IndexOutOfBoundsException(outOfBoundsMsg(index));  </li>
<li>    }  </li>
<li>  </li>
<li>    private void rangeCheckForAdd(int index) {  </li>
<li>        if (index &lt; 0 || index &gt; size)  </li>
<li>            throw new IndexOutOfBoundsException(outOfBoundsMsg(index));  </li>
<li>    }  </li>
<li>  </li>
<li>    private String outOfBoundsMsg(int index) {  </li>
<li>        return "Index: "+index+", Size: "+size;  </li>
<li>    }  </li>
<li>  </li>
<li>    private void checkForComodification() {  </li>
<li>        if (this.modCount != l.modCount)  </li>
<li>            throw new ConcurrentModificationException();  </li>
<li>    }  </li>
<li>}  </li>
<li>  </li>
<li>class RandomAccessSubList&lt;E&gt; extends SubList&lt;E&gt; implements RandomAccess {  </li>
<li>    RandomAccessSubList(AbstractList&lt;E&gt; list, int fromIndex, int toIndex) {  </li>
<li>        super(list, fromIndex, toIndex);  </li>
<li>    }  </li>
<li>  </li>
<li>    public List&lt;E&gt; subList(int fromIndex, int toIndex) {  </li>
<li>        return new RandomAccessSubList&lt;&gt;(this, fromIndex, toIndex);  </li>
<li>    }  </li>
<li>}  </li>
</ol>

<h1><strong>6. AbstractSet</strong></h1>
<p>        AbstractSet的定义如下：</p>
<p><b>[java]</b> <a href="http://blog.csdn.net/eson_15/article/details/51139978#" rel="external nofollow noreferrer">view plain</a> <a href="http://blog.csdn.net/eson_15/article/details/51139978#" rel="external nofollow noreferrer">copy</a></p>
<p> <a href="https://code.csdn.net/snippets/1644590" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL2NvZGUuY3Nkbi5uZXQvYXNzZXRzL0NPREVfaWNvLnBuZw==.jpg"></a><a href="https://code.csdn.net/snippets/1644590/fork" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL2NvZGUuY3Nkbi5uZXQvYXNzZXRzL2ljb19mb3JrLnN2Zw==.jpg"></a></p>
<ol>
<li>public abstract class AbstractSet&lt;E&gt; extends AbstractCollection&lt;E&gt; implements Set&lt;E&gt; {}  </li>
</ol>
<p>        AbstractSet是一个继承与AbstractCollection，并且实现了Set接口的抽象类。由于Set接口和Collection接口中的API完全一样，所以Set也就没有自己单独的API。和AbstractCollection一样，它实现了List中除iterator()和size()外的方法。所以源码和AbstractCollection的一样。<br />        AbstractSet的主要作用：它实现了Set接口总的大部分函数，从而方便其他类实现Set接口。</p>
<h1><strong>7. Iterator</strong></h1>
<p>        Iterator的定义如下：</p>
<p><b>[java]</b> <a href="http://blog.csdn.net/eson_15/article/details/51139978#" rel="external nofollow noreferrer">view plain</a> <a href="http://blog.csdn.net/eson_15/article/details/51139978#" rel="external nofollow noreferrer">copy</a></p>
<p> <a href="https://code.csdn.net/snippets/1644590" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL2NvZGUuY3Nkbi5uZXQvYXNzZXRzL0NPREVfaWNvLnBuZw==.jpg"></a><a href="https://code.csdn.net/snippets/1644590/fork" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL2NvZGUuY3Nkbi5uZXQvYXNzZXRzL2ljb19mb3JrLnN2Zw==.jpg"></a></p>
<ol>
<li>public interface Iterator&lt;E&gt; {}  </li>
</ol>
<p>        Iterator是一个接口，它是集合的迭代器。集合可以通过Iterator去遍历其中的元素。Iterator提供的API接口包括：是否存在下一个元素，获取下一个元素和删除当前元素。<br />
<br />        注意：Iterator遍历Collection时，是fail-fast机制的。即，当某一个线程A通过iterator去遍历某集合的过程中，若该集合的内容被其他线程所改变了，那么线程A访问集合时，就会抛出CurrentModificationException异常，产生fail-fast事件。下面是Iterator的几个API。</p>
<p><b>[java]</b> <a href="http://blog.csdn.net/eson_15/article/details/51139978#" rel="external nofollow noreferrer">view plain</a> <a href="http://blog.csdn.net/eson_15/article/details/51139978#" rel="external nofollow noreferrer">copy</a></p>
<p> <a href="https://code.csdn.net/snippets/1644590" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL2NvZGUuY3Nkbi5uZXQvYXNzZXRzL0NPREVfaWNvLnBuZw==.jpg"></a><a href="https://code.csdn.net/snippets/1644590/fork" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL2NvZGUuY3Nkbi5uZXQvYXNzZXRzL2ljb19mb3JrLnN2Zw==.jpg"></a></p>
<ol>
<li>// Iterator的API  </li>
<li>abstract boolean hasNext()  </li>
<li>abstract E next()  </li>
<li>abstract void remove()  </li>
</ol>

<h1><strong>8. ListIterator</strong></h1>
<p>        ListIterator的定义如下：</p>
<p><b>[java]</b> <a href="http://blog.csdn.net/eson_15/article/details/51139978#" rel="external nofollow noreferrer">view plain</a> <a href="http://blog.csdn.net/eson_15/article/details/51139978#" rel="external nofollow noreferrer">copy</a></p>
<p> <a href="https://code.csdn.net/snippets/1644590" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL2NvZGUuY3Nkbi5uZXQvYXNzZXRzL0NPREVfaWNvLnBuZw==.jpg"></a><a href="https://code.csdn.net/snippets/1644590/fork" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL2NvZGUuY3Nkbi5uZXQvYXNzZXRzL2ljb19mb3JrLnN2Zw==.jpg"></a></p>
<ol>
<li>public interface ListIterator&lt;E&gt; extends Iterator&lt;E&gt; {}  </li>
</ol>
<p>        ListIterator是一个继承Iterator的接口，它是队列迭代器。专门用于遍历List，能提供向前和向后遍历。相比于Iterator，它新增了添加、是否存在上一个元素、获取上一个元素等API接口：</p>
<p><b>[java]</b> <a href="http://blog.csdn.net/eson_15/article/details/51139978#" rel="external nofollow noreferrer">view plain</a> <a href="http://blog.csdn.net/eson_15/article/details/51139978#" rel="external nofollow noreferrer">copy</a></p>
<p> <a href="https://code.csdn.net/snippets/1644590" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL2NvZGUuY3Nkbi5uZXQvYXNzZXRzL0NPREVfaWNvLnBuZw==.jpg"></a><a href="https://code.csdn.net/snippets/1644590/fork" rel="external nofollow noreferrer"><img src="/assets/blank.gif" data-echo="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL2NvZGUuY3Nkbi5uZXQvYXNzZXRzL2ljb19mb3JrLnN2Zw==.jpg"></a></p>
<ol>
<li>// 继承于Iterator的接口  </li>
<li>abstract boolean hasNext()  </li>
<li>abstract E next()  </li>
<li>abstract void remove()  </li>
<li>// 新增API接口  </li>
<li>abstract void add(E object)  </li>
<li>abstract boolean hasPrevious()  </li>
<li>abstract int nextIndex()  </li>
<li>abstract E previous()  </li>
<li>abstract int previousIndex()  </li>
<li>abstract void set(E object)  </li>
</ol>
<p>Collection的架构就讨论到这吧，如果有问题欢迎留言指正~</p>
<p>转载：http://blog.csdn.net/eson_15/article/details/51139978</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 05:45:17</div>
		
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.iamivan.net/tag/java%e9%9b%86%e5%90%88%e6%a1%86%e6%9e%b6%e6%ba%90%e7%a0%81collection/" title="java集合框架源码Collection">java集合框架源码Collection</a>        </div> -->
	</section>
	
	

		<div id="similar">

		<h3>java集合框架02——Collection架构与源码分析的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/z7ZQZZp.html" rel="bookmark">java集合框架07&mdash;&mdash;Map架构与源码分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前几节我们对Collection以及Collection中的List部分进行了分析,Collection中还有个Set,由于Set是基于Map实现的,所以这里我们先分析Map,后面章节再继续学习Set.首先我们看下Map架构图:         从图中可以看出:         1. Map是一个接口,Map中存储的内容是键值对(key-value).         2. 为了方便,我们抽象出AbstractMap类来让其他类继承,该类实现了Map中的大部分API,其他Map的具体实现就可以通			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zwWmlmz.html" rel="bookmark">java中的&equals;&equals;、equals&lpar;&rpar;、hashCode&lpar;&rpar;源码分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1. == java中的==是比较两个对象在JVM中的地址.比较好理解.看下面的代码: public class ComAddr{     public static void main(String[] args) throws Exception {         String s1 = &quot;nihao&quot;;         String s2 = &quot;nihao&quot;;         String s3 = new String(&quot;nihao&quot;)			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bEWo0Zp.html" rel="bookmark">CI框架装载器Loader&period;php源码分析&lowbar;php实例</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				顾名思义,装载器就是加载元素的,使用CI时,经常加载的有: $this-&gt;load-&gt;library() $this-&gt;load-&gt;view() $this-&gt;load-&gt;model() $this-&gt;load-&gt;database() $this-&gt;load-&gt;helper() $this-&gt;load-&gt;config() $this-&gt;load-&gt;add_package_path() 复制代码 代码如下: /**  * L			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/zOJak5p.html" rel="bookmark">java集合框架03&mdash;&mdash;ArrayList和源码分析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				   上一章学习了Collection的架构,并阅读了部分源码,这一章开始,我们将对Collection的具体实现进行详细学习.首先学习List.而ArrayList又是List中最为常用的,因此本章先学习ArrayList.先对ArrayList有个整体的认识,然后学习它的源码,深入剖析ArrayList. 1. ArrayList简介     首先看看ArrayList与Collection的关系:     ArrayList的继承关系如下: [java] view plain copy  			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/pnRO2Wp.html" rel="bookmark">java集合框架10&mdash;&mdash;TreeMap和源码分析（一）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				版权声明:尊重博主原创文章,转载请注明出处哦~http://blog.csdn.net/eson_15/article/details/51217741 目录(?)[+] 前面讨论完了HashMap和HashTable的源码,这一节我们来讨论一下TreeMap.先从整体上把握TreeMap,然后分析其源码,深入剖析TreeMap的实现. 1. TreeMap简介         TreeMap是一个有序的key-value集合,它内部是通过红-黑树实现的,如果对红-黑树不太了解,请先参考下这篇博			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/bEWaDnp.html" rel="bookmark">OkHttp 3&period;7源码分析（一）&mdash;&mdash;整体架构</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				OkHttp3.7源码分析文章列表如下: OkHttp源码分析--整体架构 OkHttp源码分析--拦截器 OkHttp源码分析--任务队列 OkHttp源码分析--缓存策略 OkHttp源码分析--多路复用 OkHttp是一个处理网络请求的开源项目,是Android端最火热的轻量级框架,由移动支付Square公司贡献用于替代HttpUrlConnection和Apache HttpClient.随着OkHttp的不断成熟,越来越多的Android开发者使用OkHttp作为网络框架. 之所以可以			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/MvY7PNb.html" rel="bookmark">解析Java中PriorityQueue优先级队列结构的源码及用法&lowbar;java</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.PriorityQueue的数据结构 JDK7中PriorityQueue(优先级队列)的数据结构是二叉堆.准确的说是一个最小堆. 二叉堆是一个特殊的堆, 它近似完全二叉树.二叉堆满足特性:父节点的键值总是保持固定的序关系于任何一个子节点的键值,且每个节点的左子树和右子树都是一个二叉堆. 当父节点的键值总是大于或等于任何一个子节点的键值时为最大堆. 当父节点的键值总是小于或等于任何一个子节点的键值时为最小堆. 下图是一个最大堆 priorityQueue队头就是给定顺序的最小元素. prio			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M6Z6ONM.html" rel="bookmark">OkHttp 3&period;7源码分析（三）&mdash;&mdash;任务队列</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				OkHttp3.7源码分析文章列表如下: OkHttp源码分析--整体架构 OkHttp源码分析--拦截器 OkHttp源码分析--任务队列 OkHttp源码分析--缓存策略 OkHttp源码分析--多路复用 前面的博客已经提到过,OkHttp的一个高效之处在于在内部维护了一个线程池,方便高效地执行异步请求.本篇博客将详细介绍OkHttp的任务队列机制. 1. 线程池的优点 OkHttp的任务队列在内部维护了一个线程池用于执行具体的网络请求.而线程池最大的好处在于通过线程复用减少非核心任务的损耗			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.iamivan.net/a/M94ga4b.html" rel="bookmark">OkHttp 3&period;7源码分析（五）&mdash;&mdash;连接池</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				OkHttp3.7源码分析文章列表如下: OkHttp源码分析--整体架构 OkHttp源码分析--拦截器 OkHttp源码分析--任务队列 OkHttp源码分析--缓存策略 OkHttp源码分析--多路复用 接下来讲下OkHttp的连接池管理,这也是OkHttp的核心部分.通过维护连接池,最大限度重用现有连接,减少网络连接的创建开销,以此提升网络请求效率. 1. 背景 1.1 keep-alive机制 在HTTP1.0中HTTP的请求流程如下: 这种方法的好处是简单,各个请求互不干扰.但在复杂			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/apX2gvb.html" rel="bookmark" class="title">抠图&mdash;套索工具和魔术棒工具篇</a>
					<div>
						在经典的这段时间,经常在PS版区学习,看了不少朋友的帖子,学到了不少东西,在我所看到的帖子里,有很多朋友提到扣图这个问题,所以我们自然而然的就想到选区,又不得不联想到某些工具或命令.就像人一吃饭就要想 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/5zOgAqz.html" rel="bookmark" class="title">CSS 滤镜&mdash;&mdash;Glow 滤镜</a>
					<div>
						css|滤镜 对一个对象使用&quot;glow&quot;属性后,这个对象的边缘就会产生类似发光的效果. Glow 滤镜语法 {filter:glow(color=color,strength)}  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5AYRBp.html" rel="bookmark" class="title">有选择地删除金山WPS2009最近文档记录</a>
					<div>
						金山WPS2009窗口的&quot;文件&quot;菜单中总会显示一些最近编辑的文档.不过即使不是常用文件只要打开过就会被记录到文件菜单下,这就有点浪费空间了.其实,在WPS2009个人版中我们可以方 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pPNWZqb.html" rel="bookmark" class="title">Excel中查询生日的公农历重合日</a>
					<div>
						可能好多人因为传统习惯,会过农历生日,于是带来一个好奇的问题,生日到哪一年公农历会重合?一定要查吗?好吧,算你狠,虽然有19年公农历会重合一说,实际上间隔年数也的确接近19倍数,就用&quot;公农历 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bj7EqmM.html" rel="bookmark" class="title">C&plus;&plus;语言基础-入门简介</a>
					<div>
						C++是个强大的语言,可以用于做别的语言做不了的工作.但是,这种强大功能是有代价的.开始使用C++时,你可能会遇到内存溢出和访问失效等问题,使程序死机.这里用最简短的篇幅介绍C++语言基础.C++语言 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7k1oAz.html" rel="bookmark" class="title">Vmware虚拟机下如何迁移Oracle RAC</a>
					<div>
						最近虚拟机下的Oracle 10g RAC搬家,搬家完毕之后,Oracle 集群resource之VIP无法正常启动,收到了CRS-0233: Resource or relatives are cu ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MxPmdmM.html" rel="bookmark" class="title">JavaScript中的acos&lpar;&rpar;方法使用详解</a>
					<div>
						 此方法返回的弧度的反余弦值.ACOS方法返回0和PI对于x-1和1之间弧度的数值.如果数的值超出这个范围,则返回NaN. 语法   1 Math.acos( x ) ; 下面是参数的详细信息: x  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MyrVDkp.html" rel="bookmark" class="title">PS鼠绘甜美高跟鞋图标</a>
					<div>
						PS鼠绘甜美高跟鞋图标         注:更多请关注photoshop教程 栏目,三联PS教程群:181754111欢迎你的加入 分类: PS鼠绘教程 ps图标制作教程					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MW1Rerz.html" rel="bookmark" class="title">Win7系统安装更新8024402f出错怎么办</a>
					<div>
						有很多使用win7的朋友发现在Windows7中运行Windows Update在线安装系统更新时,经常会遇到故障代码为 8024402f 的未知错误的提示框.那遇到这种问题要怎么办呢?下面来看看Wi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/z7220rp.html" rel="bookmark" class="title">设计是让用户觉得好用，而不是好看</a>
					<div>
						工程师最常犯的毛病,就是觉得&quot;设计&quot;不干他们的事.&quot;我只负责把功能写出来,UI就交给美术了.&quot;他们常常这样说.问题是,一个好UI,根本不只是美术这么简单,它必须 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MN1a8xb.html" rel="bookmark" class="title">不得不知的U盘强悍病毒</a>
					<div>
						  使用U盘时我们一定要注意这两种病毒: 文件夹模仿者&quot;(Win32.Troj.FakeFolderT.yl.1407388),这是一个通过U盘传播的广告程序,它会将自己伪装成U盘中的文件夹 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zVwPJ4b.html" rel="bookmark" class="title">静态网页-求大哥们帮做一个简单的购物网页。</a>
					<div>
						问题描述 求大哥们帮做一个简单的购物网页. 小弟本人是IT新手加菜鸟,刚上大一,这学期初学习了HTML静态网页制作,现在有道结课作业,要求如下: 至少应该有主页.注册登陆页面及其他商品介绍的页面.主页 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/pd6Q63b.html" rel="bookmark" class="title">Java上的try catch并不影响性能（转）</a>
					<div>
						转自:http://blog.csdn.net/tao_zi7890/article/details/17584813 最近因为担心自己开发的库不稳定,会影响到接入产品的正常运行,在代码的不少地方都加 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mq84rkb.html" rel="bookmark" class="title">mysql 5&period;6 原生Online DDL解析</a>
					<div>
						做MySQL的都知道,数据库操作里面,DDL操作(比如CREATE,DROP,ALTER等)代价是非常高的,特别是在单表上千万的情况下,加个索引或改个列类型,就有可能堵塞整个表的读写. 然后 mysq ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MN14aNb.html" rel="bookmark" class="title">ios-显示alertView键盘打不开</a>
					<div>
						问题描述 显示alertView键盘打不开 创建AlertView : UIAlertView * alert = [[UIAlertView alloc] initWithTitle:nil mes ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mg37P8M.html" rel="bookmark" class="title">&period;Net 的数学库计算精度太差？？</a>
					<div>
						问题描述 在程序中要计算一个很小的数的指数,即Math.Exp(x)其中x非常小.结果发现居然计算出来的结果是错的.用vc2010验证了一下,也是错的.在vc6下面计算,得到了正确的结果.怎么微软的库 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrWYZ4p.html" rel="bookmark" class="title">php的 zend opcache VS apc 性能比较</a>
					<div>
						如果你关注php,那么你会发现Zend Optimizer+将要包含在php5.5中发布.并且Zend Optimizer+更名为zend opcache.那么zend opcache的性能到底如何呢 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M1lYBjb.html" rel="bookmark" class="title">网络视频：谁动了我的版权？</a>
					<div>
						今年这个夏天,两场热战占据了屏幕,一场是眼下激战正酣的南非世界杯,一场是正在热播的电视剧新版&lt;三国&gt;.然而,就在它们点燃了收视热潮的时候,还有另外一场看不见的暗战也在展开,那就是网络视频的 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MrXXw4z.html" rel="bookmark" class="title">fastjson常见问题</a>
					<div>
						1. 怎么获得fastjson? 你可以通过如下地方下载fastjson: maven中央仓库: http://central.maven.org/maven2/com/alibaba/fastjso ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/p5ZROBz.html" rel="bookmark" class="title">win8-critical structure corruption（Ntfs&period;sys&rpar; 问题</a>
					<div>
						问题描述 critical structure corruption(Ntfs.sys) 问题 win8自动更新后出现我的情况是系统自动更新,开机后就出现critical structure corr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MlK1jOb.html" rel="bookmark" class="title">从紫金矿业到BP差距有多大</a>
					<div>
						一个月来,紫金矿业股价以一种诡异的上涨态势大幅超过了污染爆发前.而对老百姓来说,看不懂的不止其股价,还有整个污染事件的进展,其信息披露是否违规.相关污染到底属于何种程度.污染物善后情况.责任人处理情况 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zV0OkBM.html" rel="bookmark" class="title">android 客户端与服务端通信</a>
					<div>
						问题描述 android 客户端与服务端通信 各位大神,我想用两个fragment制作两个页面,一个页面(fragment1)实现服务器与客户端的连接,另一个(fragment2)实现收发数据,但fr ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bK5rlWp.html" rel="bookmark" class="title">由3Q之争联想到地方网站的自我保护问题</a>
					<div>
						中介交易 http://www.aliyun.com/zixun/aggregation/6858.html&quot;&gt;SEO诊断 淘宝客 云主机 技术大厅 这段时间3Q之争闹得沸沸扬扬,炒作 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/M12x8rp.html" rel="bookmark" class="title">《构建实时机器学习系统》一2&period;3　实时线性分类器介绍</a>
					<div>
						2.3 实时线性分类器介绍 2.3.1 广义线性模型的定义 (广义)线性模型是机器学习发展几十年来理论和工具上最为完备的模型:不管是分类还是预测,线性模型都可以进行实时更新和预测:线性模型的解释性非常 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/b2Z4x4b.html" rel="bookmark" class="title">美云计算电话公司RingCentral融资1000万美元</a>
					<div>
						北京时间9月9日早间消息,http://www.aliyun.com/zixun/aggregation/13595.html&quot;&gt;美国云计算电话系统提供商RingCentral在新一轮 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/Mr2qlVM.html" rel="bookmark" class="title">docker快速入门教程&lowbar;docker</a>
					<div>
						10分钟教会大家如何玩转Docker,这是 1.前言 进入云计算的时代,各大云提供商AWS,阿里云纷纷推出针对Docker的服务,现在Docker是十分火爆,那么Docker到底是什麽,让我们来体验一 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/zJOP0wb.html" rel="bookmark" class="title">Nginx&plus;Keepalived&lpar;双机热备&rpar;搭建高可用负载均衡环境&lpar;HA&rpar;</a>
					<div>
						基于 Nginx+Tomcat+Redis负载均衡Session共享来实现后续的功能 个人微信小程序.是关于人工智能的.应用是百度大脑 和 腾讯优图的人脸识别 有问题加QQ:783021975 验证问 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MYd2WQb.html" rel="bookmark" class="title">安全漏洞提醒思科发布公告修复4个漏洞</a>
					<div>
						新华网天津2月2日电 (记者 张建新) 国家计算机网络入侵防范中心安全漏洞周报称,1月25日至31日,安全漏洞共计48个,其中高危漏洞28个,总量相比前一周略有下降.其中对我国用户影响较大安全漏洞有: ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/MqgoOZz.html" rel="bookmark" class="title">腾讯COO任宇昕：携手作者迎接网络文学下一个高峰</a>
					<div>
						&quot;在过去长达十年的http://www.aliyun.com/zixun/aggregation/8242.html&quot;&gt;数字内容发展过程中,我们深刻地感受到,数字内容如果想获 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.iamivan.net/a/bEJ5K9M.html" rel="bookmark" class="title">分布式锁的三种实现方式</a>
					<div>
						分布式锁大有用途,比如用在减库存操作.流水号生成,分布式计数器等.分布式锁服务在大家的项目中或许用的不多,因为大家都把排他放在数据库那一层来挡.当大量的行锁.表锁.事务充斥着数据库的时候.一般web应 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>热搜</span>
		</div>
		<div class="box-content">
					</div>
	</div>


</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 iVAN        | info#iamivan.net        | 11 q. 0.041 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <!-- <script src="/assets/js/jquery.js"></script>
  <script src="/assets/js/bootstrap.min.js"></script> -->
  <div style=" display: none ";>
  </div>

<script src="/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
    </script>
</body>
</html>
